--------------------------------------------------
-- FontList.lua
-- 	2014/05/27 - 2014/05/30
-- 					hksy
--------------------------------------------------

--[[
	FontList.Search(fontlist,filter,fFirst)
	  ɈvtHg̃Xg쐬܂B
	  ɂLuãp^[}b`OLłB
	  	1.table		fontlist		: 郊Xg
		2.string	filter			: }XN
		3.boolean	fFirst	= false		: true = 擪v / false = v

		 : list	= FontList.Search(fontlist,"Arial", true)	-- "Arial"n܂tHgꗗ擾
		     list	= FontList:Search("[^@]",true)			-- tHĝ݂擾

	FontList.Sort(fontlist)
	  tHg̃XgɃ\[gĕԋp܂B
	  	1.table		fontlist		: \[g郊Xg

		 : list	= FontList.Sort(fontlist)			-- "Arial"n܂tHgꗗ擾
		     list	= FontList:Sort()				-- FontList\[giŎgnĂj

	FontList.New(charset)
	  w蕶R[h̃tHg̃Xg쐬܂B
	  FontListgɂׂẴtHg̃XgێĂ܂B
	  	1.number	charset	= 0		: R[h ȉ̂悤Ȓ萔gpł܂
			FontList.Charset.Default	: S
			FontList.Charset.ANSI		: ANSI
			FontList.Charset.Shift_JIS	: Shift-JIS

		 : fontlist	= FontList.New(FontList.Charset.Shift_JIS)	-- Shift-JISZbg̈ꗗ擾

	1fontlist́A
		fontlist.Search(fontlist, ... )
		fontlist:Search( ... )
	̂悤ɁA . ihbgj̑ : iRjgƂŏȗ邱Ƃł܂B

]]

--------------------------------------------------
-- Utility
--------------------------------------------------

local function strsort(list, slist)
	local byte	= string.byte
	local len	= string.len
	local listn	= #list
	local blist	= {}
	local ilist	= {}
	local slist	= slist	or {}

	for i=1,listn do
		blist[i]	= {byte(list[i],1,len(list[i]))}
		ilist[i]	= i
	end

	function cmp(a,b)
		local al,bl	= #blist[a], #blist[b]
		local min
		if(al<bl)then	min	= al
		else		min	= bl
		end

		for i=1,min do
			if	(blist[a][i] < blist[b][i])then
				return true
			elseif	(blist[b][i] < blist[a][i])then
				return false
			end
		end
		return al<bl
	end

	table.sort(ilist,cmp)

	for i=1,listn do
		slist[i]	= list[ilist[i]]
	end

	return slist
end

--------------------------------------------------

local function SetFunction(list)
	-- ʂfor
	list.Search	= FontList.Search
	list.Sort	= FontList.Sort
end
local function New()
	local list	= {}
	SetFunction(list)
	return list
end

--------------------------------------------------

require("hkmod")

FontList	= hkmod.GetFontList()

FontList.Charset	= {	-- Zbgp萔
	ANSI		=   0,	--   ӖƂLOGFONTƂŒׂĂB
	Default		=   1,	--   Defaultw肵Ă̂łB
	Symbol		=   2,	--   ȗDefaultB
	Mac		=  77,
	Shift_JIS	= 128,
	Hangul		= 129,
	Johab		= 130,
	GB2312		= 134,
	ChineseBIG5	= 136,
	Greek		= 161,
	Turkish		= 162,
	Vietnamese	= 163,
	Hebrew		= 177,
	Arabic		= 178,
	Baltic		= 186,
	Russian		= 204,
	Thai		= 222,
	EastEurope	= 238,
	OEM		= 255
}


function FontList.Search(fontlist, filter,fFirst)
	local list	= New()
	local find	= string.find
	local j		= 1

	filter		= filter	or ""

	for i=1,#fontlist do
		local m	= find(fontlist[i],filter)

		if(m~=nil and ( m==1 or (not fFirst and m>0) ) )then
			list[j]	= fontlist[i]
			j	= j+1
		end
	end

	return list
end

function FontList.Sort(fontlist)
	if(fontlist==nil)then
		return
	end

	if(FontList==fontlist)then
		strsort(FontList, FontList)
	else
		local list	= New()
		strsort(fontlist, list)
		return list
	end
end

function FontList.New(charset)
	local list	= hkmod.GetFontList(charset)
	SetFunction(list)
	return list
end




