--------------------------------------------------
-- PolygonText.lua
-- 	2015/09/08 - 2015/09/15
-- 					hksy
--------------------------------------------------

--[[
Wn̓tHgf[^ɍ킹YłA
AviUtlƂ͔΂ł邱ƂɒӂĂB

GetGlyphPolygon(font, char, div)
	wtHg̕f[^|Sŕ`ł悤ɂf[^擾܂B
	
	  01 string	font		: tHg
	  02 string	char		: R[hi2oCg̏ꍇ1oCgڂ͏ʂɒuĂ ""=0x82A0j
	  03 number	div		: 
	߂l
	  01 table	GlyphData	: Ot
	  02 table	PointData	: Ot
	  03 table	TriangleData	: Op`f[^


--------------------------------------------------
-- ʊ֐
--------------------------------------------------

GlyphBezierToLinear(GlyphData, div)
	hkmod.GetGlyph()Ŏ擾Ot𒼐ŕ\悤ϊ܂B
	
	  01 table	GlyphData	: Ot
	  02 number	div		: 
	߂l
	  01 table	PointData	: Ot

hkmod.Tessellation(PointData)
	_Op`|Sŕ\悤̗vfɕ܂B
	OtƗ\\ԂႤ߁A
	table.reverse(t)ĩXNvgɒǉ֐j𗘗pϊ邱Ƃ߂܂B
	
	  01 table	PointData	: 
	߂l
	  01 table	TessData	: ebZ[Ṽf[^

PointToTriangleData(PointData, TessData)
	ebZ[Vf[^Op`|SɕA
	`悵₷`ɕϊ܂B
	
	  01 table	PointData	: 
	  02 table	TessData	: 
	߂l
	  01 table	TriangleData	: Op`f[^

--------------------------------------------------
-- f[^`
--------------------------------------------------

GlyphData	= {
	width		: TCY
	height		: 
	x		: ̍W
	y		:   WnY
	boxw		: ۂɕ`悳TCY
	boxh		:   width,height ̗]؂lߌTCY
	inleading	: 
	exleading	: 
	normalize	: W̒lŊƂ񂶂̒lɂȂ

	{	-- [1] Polygon
		start	= { x, y }	: curve[1]̊Jn_
		{	-- [1] curve
			type		: Ԏ
					    1=`/2=2xWF/3=3xWF
			{ x, y },	: Note	: type=3ł΁Astart,1,2,3 4_ŕԁA3,4,5,6ŕԁcƑ
			...		  	  type=2̂Ƃ͗]肪ołǂȂłȂłȂ
		},
		{	-- [2] Curve
			...
		},
		...
	},
	{	-- [2] Polygon
		...
	},
	...
}

PointData	= {
	{	-- [1] Polygon
		{ x, y },	-- [1] Point
		{ x, y },	-- [2] Point
		...
	},
	{	-- [2] Polygon
		...
	},
	...
}

TessData	= {
	{	-- [1] Polygon
		-- 	hԂ̈̃|Ŝ߁Aς邱Ƃ܂
		type		: Op`f[^̎
				  4 = GL_TRIANGLES	ꂼƗOp`
				  5 = GL_TRIANGLE_STRIP	݂Ⴂ
				  6 = GL_TRIANGLE_FAN	ŏ̓_ƂĐ`
		{ polyid, index },	-- [1] RefPoint	PointData[polyid][index]
		{ polyid, index },	-- [2] RefPoint
		...
	},
	{	-- [2] Polygon
		...
	},
	...
}

TriangleData	= {
	{	-- [1] Triangle
		{ x=x, y=y },
		{ x=x, y=y },
		{ x=x, y=y }
	},
	{	-- [2] Triangle
		...
	},
	...
}

]]

require("hkmod")
require("Interpolation")

--------------------------------------------------

function table.reverse(t)
	local r	= {}
	local n	= #t

	for k,v in ipairs(t) do
		r[n-k+1]	= v
	end

	return r
end

--------------------------------------------------

function SignArea(p)
	-- tʐ

	local n	= #p

	local s	= 0
	for i=1,n do
		local a	= p[i]
		local b	= p[i%n+1]	-- 1, 2, 3, ..., n-1, 1, ...
		s	= s + a[1]*b[2] - a[2]*b[1]
	end
	return s*0.5
end

local function isCross(p0, p1, p2, p3)
	-- p0,p1  p2,p3̐邩
	--  = true / Ȃ = false

	local function isRange(v)
		return (0<=v and v<=1)
	end

	local dax,day	= p1.x-p0.x,p1.y-p0.y
	local dbx,dby	= p3.x-p2.x,p3.y-p2.y
	local dabx,daby	= p2.x-p0.x,p2.y-p0.y
	local d		= dax*dby-day*dbx
	if(d==0)then		return false	end	-- s
	local r		= (dby*dabx-dbx*daby)/d
	local s		= (day*dabx-dax*daby)/d
	return (isRange(r) and isRange(s))
end

--------------------------------------------------

function GlyphBezierToLinear(GlyphData, div)
	-- GlyphData(Bezier)	-> PointData(Linear)
	PointData	= {}

	local poly_n	= #GlyphData
	for pi=1,poly_n do
		local poly	= GlyphData[pi]
		local curve_n	= #poly

		local points	= {}
		local pn	= 0
		local p0	= poly.start

		for ci=1,curve_n do
			local curve	= poly[ci]
			local point_n	= #curve
			local isLast	= (ci>=curve_n)

			if(curve.type==1)then		-- `
				pn		= pn + 1
				points[pn]	= p0

				for i=1,point_n-1 do
					pn		= pn + 1
					points[pn]	= curve[i]
				end
				p0		= curve[point_n]

			elseif(curve.type==2)then	-- 2xWF Ԃ񗈂Ȃ͂ǈꉞ
				for i=1,point_n-1 do
					local p1	= curve[i  ]
					local p2	= curve[i+1]
					local pm
					if(not isLast)then	-- ̓_Ƃ̒_
						pm	= {(p1[1]+p2[1])/2, (p1[2]+p2[2])/2}
					else	pm	= p2	-- Ō͐_
					end

					for j=0,div-1 do
						local t		= j/div
						local px	= Interpolation.Bezier2(t, p0[1], p1[1], pm[1])
						local py	= Interpolation.Bezier2(t, p0[2], p1[2], pm[2])
						pn		= pn + 1
						points[pn]	= {px, py}	-- Jn_0Ŋ܂܂Ă̂ō폜
					end

					p0		= pm
				end

			elseif(curve.type==3)then	-- 3xWF
				for i=1,point_n,3 do
					local p1	= curve[i  ]
					local p2	= curve[i+1]
					local p3	= curve[i+2]

					for j=0,div-1 do
						local t		= j/div
						local px	= Interpolation.Bezier(t, p0[1], p1[1], p2[1], p3[1])
						local py	= Interpolation.Bezier(t, p0[2], p1[2], p2[2], p3[2])
						pn		= pn + 1
						points[pn]	= {px, py}
					end

					p0		= p3
				end
			end
		end

		pn	= pn + 1
		points[pn]	= p0

		PointData[pi]	= points
	end
	return PointData
end

--------------------------------------------------

local function IndexToKeyTable(p)
	p.x	= p[1]
	p.y	= p[2]
	return p
end

local function TableJoint(t1, t2)
	-- t1[2], t2[2]
	-- -> t1 = { t1[1], t1[2], t2[1], t2[2] }

	local n	= #t1
	for k,v in ipairs(t2) do
		t1[k+n]	= v
	end
end

function CullingTriangle(p1, p2, p3)
	-- tʐςiEjɂȂ悤ɎOp`|Se[u쐬
	local t	= {p1, p2, p3}

	if(SignArea(t)>0)then
		t	= table.reverse(t)
	end

	return t
end

function TrianglesTessData(PointData, tess)
	-- ƗOp`
	local i2k	= IndexToKeyTable
	local triangle	= {}
	local tn	= 0

	for i=1,#tess,3 do
		tn	= tn + 1
		triangle[tn]	= CullingTriangle(
			i2k(PointData[ tess[i  ][1] ][ tess[i  ][2] ]),
			i2k(PointData[ tess[i+1][1] ][ tess[i+1][2] ]),
			i2k(PointData[ tess[i+2][1] ][ tess[i+2][2] ])
		)
	end

	return triangle
end

function StripTessData(PointData, tess)
	-- 
	local i2k	= IndexToKeyTable
	local triangle	= {}

	for i=1,#tess-2 do
		triangle[i]	= CullingTriangle(
			i2k(PointData[ tess[i  ][1] ][ tess[i  ][2] ]),
			i2k(PointData[ tess[i+1][1] ][ tess[i+1][2] ]),
			i2k(PointData[ tess[i+2][1] ][ tess[i+2][2] ])
		)
	end

	return triangle
end

function FanTessData(PointData, tess)
	-- `
	local i2k	= IndexToKeyTable
	local triangle	= {}

	for i=1,#tess-2 do
		triangle[i]	= CullingTriangle(
			i2k(PointData[ tess[1  ][1] ][ tess[1  ][2] ]),
			i2k(PointData[ tess[i+1][1] ][ tess[i+1][2] ]),
			i2k(PointData[ tess[i+2][1] ][ tess[i+2][2] ])
		)
	end

	return triangle
end

function TriangleTessData(PointData, tess)
	-- Op`
	local i2k	= IndexToKeyTable

	return {CullingTriangle(
		i2k(PointData[ tess[1][1] ][ tess[1][2] ]),
		i2k(PointData[ tess[2][1] ][ tess[2][2] ]),
		i2k(PointData[ tess[3][1] ][ tess[3][2] ])
	)}
end


function PointToTriangleData(PointData, TessData)
	local TriangleData	= {}

	for i=1,#TessData do
		local tess	= TessData[i]
		local tn	= #tess

		if(tn>3)then		-- p`
			if(tess.type==4)then		-- GL_TRIANGLES
				TableJoint( TriangleData, TrianglesTessData(PointData, tess) )
			elseif(tess.type==5)then	-- GL_TRIANGLE_STRIP
				TableJoint( TriangleData, StripTessData(PointData, tess) )
			elseif(tess.type==6)then	-- GL_TRIANGLES_FAN
				TableJoint( TriangleData, FanTessData(PointData, tess) )
			end
		elseif(tn>=3)then	-- Op`
			TableJoint( TriangleData, TriangleTessData(PointData, tess) )
		end

	end

	return TriangleData
end



--------------------------------------------------

function GetGlyphPolygon(font, char, div)
	div	= div	or 1

	-- Get Glyph
	local GlyphData	= hkmod.GetGlyph(font, char)

	-- GlyphData(Bezier)	-> PointData(Linear)
	local PointData	= GlyphBezierToLinear(GlyphData, div)

	-- reverse (win32api:right -> OpenGL:left)
	for i=1,#PointData do
		PointData[i]	= table.reverse(PointData[i])
	end

	-- PointData	-> TessData(connect data)
	local TessData	= hkmod.Tessellation(PointData)

	-- PointData + TessData	-> TriangleData
	local TriangleData	= PointToTriangleData(PointData, TessData)

	return GlyphData, PointData, TriangleData
end

function GlyphPosToPixel(GlyphData, p, size)
	-- Otf[^̍WnCӃTCYɕϊ܂
	return size*p/GlyphData.normalize
end


